<CsoundSynthesizer>
<CsOptions>
-odac -Ma -b128 -B512 --midi-key=4 --midi-velocity-amp=5 -m0
</CsOptions>
<CsInstruments>

/******CHANGING THE SCALES LIVE WITH SHORTCUTS******/

;equal-tempered scale
giScale1 	ftgen 		1, 0, -12, -2,  0
;middle tone scale
giScale2 	ftgen 		2, 0, -12, -2,  0, -34, -7, 10, -14, 3, -21, -3, -27, -10, 7, -17
;pythagorean scale
giScale3 	ftgen 		3, 0, -12, -2,  0, 14, 4, -6, 8, -2, 12, 2, 16, 6, -4, 10
		massign 	0, 1

instr 1
;;INPUT
ikey		=		p4
ivel		=		p5
kreftone	invalue	"reftone"; any midi note number
ktunfreq	invalue	"tunfreq"; any frequency for it
kscale		invalue	"scale"; select scale by menu
ireftone	=		i(kreftone)
itunfreq	=		i(ktunfreq)
iscale		=		i(kscale) + 1; menu item 0 selects function table 1 etc
;;CALCULATION
icentdiff	=		1200 * logbtwo(itunfreq / cpsmidinn(ireftone)); centdifference tuning freq to usual freq
ishift		=		12 - (ireftone % 12)
indx		=		(ikey+ishift) % 12
icent		tab_i		indx, iscale; cent deviation according to function table 
ifreqeq	=		cpsmidinn(ikey); frequency for equal tempered and usual reference (a = 440 Hz)
ifreqeqtun	=		ifreqeq * cent(icentdiff); frequency for equal tempered on actual reference (tuning frequency)
ifreqscnorm	=		ifreqeq * cent(icent); frequency regarding cent deviations but usual reference (a = 440 Hz)
ifreqsctun	=		ifreqeq * cent(icent + icentdiff); frequency with correct cent deviations in scale and tuning pitch
anote		oscils		ivel, ifreqsctun, 0
kenv		linsegr	0, .1, 1, p3-0.1, 1, .1, 0
		out		anote * kenv
;;SHOW OUTPUT
Skey		sprintf	"%d", ikey
		outvalue	"key", Skey
		outvalue	"centdiff",	 icentdiff
		outvalue	"cent", icent
		outvalue	"freqeq", ifreqeq
		outvalue	"freqscnorm", ifreqscnorm
		outvalue	"freqeqtun", ifreqeqtun
		outvalue	"freqsctun", ifreqsctun
endin

instr 100; select scale by computer keyboard (digits 1-9)
Skey		invalue	"shortcuts"
kstrlen	strlenk	Skey
Sletzter	strsubk	Skey, kstrlen - 1, kstrlen
key		strchark	Sletzter
knum		=		(key > 58 || key < 49 ? 0 : key - 49);ascii number 49 = digit 1
		outvalue	"scale", knum
endin
</CsInstruments>
<CsScore>
i 100 0 3600
e
</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 681 132 512 479
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView background {43433, 43947, 32896}
ioText {242, 179} {80, 25} display 0.000000 0.00100 "key" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 64
ioText {66, 179} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Key Pressed
ioText {241, 286} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 0.0000
ioText {-1684371923, -1632653318} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {243, 212} {78, 26} display 0.000000 0.00100 "freqeq" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 329.6090
ioText {11, 210} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Usual Frequency of Key
ioText {243, 315} {78, 31} display 0.000000 0.00100 "freqscnorm" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 329.6090
ioText {11, 313} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation but usual Pitch Reference
ioText {243, 412} {78, 31} display 0.000000 0.00100 "freqsctun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 331.8477
ioText {11, 410} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation and own Reference Frequency
ioText {243, 363} {78, 31} display 0.000000 0.00100 "freqeqtun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 331.8477
ioText {11, 361} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency without Cent Deviation but with own Reference Frequency
ioText {5, 10} {484, 133} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {56832, 36608, 52736} nobackground border INPUT
ioText {6, 149} {320, 319} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground border OUTPUT
ioText {129, 104} {107, 26} editnum 443.000000 0.000001 "tunfreq" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 443.000000
ioText {121, 46} {123, 31} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Related Pitch
ioText {141, 73} {72, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Hertz)
ioText {-610629723, -1632653302} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 0.0000
ioText {-610629955, -1632653304} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {11, 284} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation because of Scale
ioText {242, 240} {80, 25} display 0.000000 0.00100 "centdiff" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 11.7287
ioText {14, 239} {222, 43} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder General Cent Deviation because of Tuning Reference
ioMenu {252, 107} {80, 24} -1 303 "scale1,scale2,scale3" scale
ioText {251, 46} {84, 49} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Show Scale
ioText {374, 11} {104, 88} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Select Scale by Keyboard Shortcuts
ioText {376, 107} {100, 25} edit 0.000000 0.00100 "shortcuts" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder type here
ioText {38, 107} {68, 26} editnum 69.000000 1.000000 "reftone" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 69.000000
ioText {23, 46} {90, 47} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Reference Tone
ioText {27, 86} {87, 25} label 0.000000 0.00100 "" center "Lucida Grande" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Midi-Number)
</MacGUI>

